BuildRequires: /proc
BuildRequires: jpackage-1.4-compat
# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support 0

# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

%define parent plexus
%define subname compiler

Name:           plexus-compiler
Version:        1.5.2
Release:        alt2_5jpp1.7
Epoch:          0
Summary:        Plexus Compiler
License:        Apache Software License 2.0
Group:          Development/Java
URL:            http://plexus.codehaus.org/
Source0:        plexus-compiler-1.5.2.tar.gz
# svn export svn://svn.plexus.codehaus.org/plexus/tags/plexus-compiler-1.5.2

Source1:        plexus-compiler-1.5.2-api-build.xml
Source2:        plexus-compiler-1.5.2-compilers-aspectj-build.xml
Source3:        plexus-compiler-1.5.2-compilers-csharp-build.xml
Source4:        plexus-compiler-1.5.2-compilers-eclipse-build.xml
Source5:        plexus-compiler-1.5.2-compilers-javac-build.xml
Source6:        plexus-compiler-1.5.2-compilers-jikes-build.xml
Source7:        plexus-compiler-1.5.2-compilers-parent-build.xml
Source8:        plexus-compiler-1.5.2-manager-build.xml
Source9:        plexus-compiler-1.5.2-parent-build.xml
Source10:       plexus-compiler-1.5.2-test-build.xml
Source11:       plexus-compiler-1.5.2-jpp-depmap.xml

Patch0:         plexus-compiler-1.5.2-JikesCompiler.patch
Patch1:         plexus-compiler-1.5.2-compilers-pom_xml.patch
Patch2:         plexus-compiler-1.5.2-aspectj-pom_xml.patch
Patch3:         plexus-compiler-1.5.2-eclipse-pom_xml.patch
Patch4:         plexus-compiler-1.5.2-jikes-pom_xml.patch


%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRequires: jpackage-utils >= 0:1.6
BuildRequires: ant >= 0:1.6
BuildRequires: ant-nodeps >= 0:1.6
%if %{with_maven}
BuildRequires: maven2-plugins >= 0:2.0.4
%endif
BuildRequires: aspectj >= 0:1.2
BuildRequires: classworlds
BuildRequires: ecj
BuildRequires: plexus-container-default
BuildRequires: plexus-utils
Requires: aspectj >= 0:1.2
Requires: classworlds
Requires: ecj
Requires: plexus-container-default
Requires: plexus-utils
%if %{gcj_support}
BuildRequires: gnu-crypto
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif
Requires(post): jpackage-utils >= 0:1.7.2
Requires(postun): jpackage-utils >= 0:1.7.2

%description
Plexus Compiler components.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n plexus-compiler-1.5.2
cp %{SOURCE1} plexus-compiler-api/build.xml
cp %{SOURCE2} plexus-compilers/plexus-compiler-aspectj/build.xml
cp %{SOURCE3} plexus-compilers/plexus-compiler-csharp/build.xml
cp %{SOURCE4} plexus-compilers/plexus-compiler-eclipse/build.xml
cp %{SOURCE5} plexus-compilers/plexus-compiler-javac/build.xml
cp %{SOURCE6} plexus-compilers/plexus-compiler-jikes/build.xml
cp %{SOURCE7} plexus-compilers/build.xml
cp %{SOURCE8} plexus-compiler-manager/build.xml
cp %{SOURCE9} build.xml
cp %{SOURCE10} plexus-compiler-test/build.xml

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav
%patch4 -b .sav

%build
%if %{with_maven}
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository

mvn-jpp -e \
-Dmaven.test.skip=true \    -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
    -Dmaven2.jpp.depmap.file=%{SOURCE11} \
    install javadoc:javadoc

#    -Dmaven.test.failure.ignore=true \

%else
pushd plexus-compiler-api
mkdir -p target/lib
build-jar-repository -s -p target/lib plexus/utils plexus/container-default classworlds
ant jar javadoc
popd

pushd plexus-compiler-manager
mkdir -p target/lib
cp ../plexus-compiler-api/target/plexus-compiler-api-1.5.2.jar target/lib/
build-jar-repository -s -p target/lib plexus/container-default plexus/utils classworlds
ant jar javadoc
popd

#pushd plexus-compiler-test
## requires maven2
#mkdir -p target/lib
#cp ../plexus-compiler-api/target/plexus-compiler-api-1.5.2.jar target/lib/
#build-jar-repository -s -p target/lib maven plexus/utils plexus/container-default classworlds junit
#ant jar javadoc
#popd

pushd plexus-compilers
# requires aspectj-1.5.0
pushd plexus-compiler-aspectj
# tests require plexus-compiler-test, which requires maven2 in turn
rm -rf src/test/java/*
#
mkdir -p target/lib
cp ../../plexus-compiler-api/target/plexus-compiler-api-1.5.2.jar target/lib/
build-jar-repository -s -p target/lib plexus/container-default plexus/utils classworlds aspectjtools aspectjrt
ant jar javadoc
popd
pushd plexus-compiler-csharp
mkdir -p target/lib
cp ../../plexus-compiler-api/target/plexus-compiler-api-1.5.2.jar target/lib/
build-jar-repository -s -p target/lib plexus/utils plexus/container-default classworlds ant ant/ant-nodeps
ant jar javadoc
popd
pushd plexus-compiler-eclipse
# tests require plexus-compiler-test, which requires maven2 in turn
rm -rf src/test/java/*
#
mkdir -p target/lib
cp ../../plexus-compiler-api/target/plexus-compiler-api-1.5.2.jar target/lib/
build-jar-repository -s -p target/lib plexus/utils plexus/container-default classworlds ecj
ant jar javadoc
popd
pushd plexus-compiler-javac
# tests require plexus-compiler-test, which requires maven2 in turn
rm -rf src/test/java/*
#
mkdir -p target/lib
cp ../../plexus-compiler-api/target/plexus-compiler-api-1.5.2.jar target/lib/
build-jar-repository -s -p target/lib plexus/utils plexus/container-default classworlds
ant jar javadoc
popd
pushd plexus-compiler-jikes
# tests require plexus-compiler-test, which requires maven2 in turn
rm -rf src/test/java/*
#
mkdir -p target/lib
cp ../../plexus-compiler-api/target/plexus-compiler-api-1.5.2.jar target/lib/
build-jar-repository -s -p target/lib plexus/utils plexus/container-default classworlds
ant jar javadoc
popd
popd
%endif

%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/plexus
install -pm 644 %{name}-api/target/%{name}-api-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{parent}/compiler-api-%{version}.jar
%add_to_maven_depmap org.codehaus.plexus %{name}-api %{version} JPP/%{parent} %{subname}-api
%if %{with_maven}
install -pm 644 %{name}-test/target/%{name}-test-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{parent}/compiler-test-%{version}.jar
%endif
%add_to_maven_depmap org.codehaus.plexus %{name}-test %{version} JPP/%{parent} %{subname}-test
install -pm 644 %{name}-manager/target/%{name}-manager-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{parent}/compiler-manager-%{version}.jar
%add_to_maven_depmap org.codehaus.plexus %{name}-manager %{version} JPP/%{parent} %{subname}-manager
install -pm 644 %{parent}-compilers/plexus-compiler-aspectj/target/%{name}-aspectj-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{parent}/compiler-aspectj-%{version}.jar
%add_to_maven_depmap org.codehaus.plexus %{name}-aspectj %{version} JPP/%{parent} %{subname}-aspectj
install -pm 644 %{parent}-compilers/plexus-compiler-csharp/target/%{name}-csharp-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{parent}/compiler-csharp-%{version}.jar
%add_to_maven_depmap org.codehaus.plexus %{name}-csharp %{version} JPP/%{parent} %{subname}-csharp
install -pm 644 %{parent}-compilers/plexus-compiler-eclipse/target/%{name}-eclipse-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{parent}/compiler-eclipse-%{version}.jar
%add_to_maven_depmap org.codehaus.plexus %{name}-eclipse %{version} JPP/%{parent} %{subname}-eclipse
install -pm 644 %{parent}-compilers/plexus-compiler-javac/target/%{name}-javac-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{parent}/compiler-javac-%{version}.jar
%add_to_maven_depmap org.codehaus.plexus %{name}-javac %{version} JPP/%{parent} %{subname}-javac
install -pm 644 %{parent}-compilers/plexus-compiler-jikes/target/%{name}-jikes-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{parent}/compiler-jikes-%{version}.jar
%add_to_maven_depmap org.codehaus.plexus %{name}-jikes %{version} JPP/%{parent} %{subname}-jikes
(cd $RPM_BUILD_ROOT%{_javadir}/%{parent} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# poms
%if %{with_maven}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-%{subname}.pom
install -pm 644 %{name}-api/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-%{subname}-api.pom
install -pm 644 %{name}-test/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-%{subname}-test.pom
install -pm 644 %{name}-manager/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-%{subname}-manager.pom
install -pm 644 %{name}s/%{name}-aspectj/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-%{subname}-aspectj.pom
install -pm 644 %{name}s/%{name}-csharp/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-%{subname}-csharp.pom
install -pm 644 %{name}s/%{name}-eclipse/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-%{subname}-eclipse.pom
install -pm 644 %{name}s/%{name}-javac/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-%{subname}-javac.pom
install -pm 644 %{name}s/%{name}-jikes/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-%{subname}-jikes.pom
%endif

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/api
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/manager
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/test
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/compilers
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/compilers/aspectj
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/compilers/csharp
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/compilers/eclipse
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/compilers/javac
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/compilers/jikes
cp -pr %{name}-api/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/api
cp -pr %{name}-manager/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/manager
%if %{with_maven}
cp -pr %{name}-test/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/test
%endif
cp -pr %{parent}-compilers/%{name}-aspectj/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/compilers/aspectj
cp -pr %{parent}-compilers/%{name}-csharp/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/compilers/csharp
cp -pr %{parent}-compilers/%{name}-eclipse/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/compilers/eclipse
cp -pr %{parent}-compilers/%{name}-javac/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/compilers/javac
cp -pr %{parent}-compilers/%{name}-jikes/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/compilers/jikes
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%{_javadir}/%{parent}/*
%if %{with_maven}
%{_datadir}/maven2/poms/*
%endif
%{_mavendepmapfragdir}
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/compiler*-%{version}.jar.*
%endif

%files javadoc
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Wed Nov 28 2007 Igor Vlasenko <viy@altlinux.ru> 0:1.5.2-alt2_5jpp1.7
- built with maven

* Tue Jul 24 2007 Igor Vlasenko <viy@altlinux.ru> 0:1.5.2-alt1_5jpp1.7
- converted from JPackage by jppimport script

